import pygame

class Button:
    def __init__( self, function, dimensions, button_surface, text, font, color_enabled, color_disabled ):
        self.x = dimensions[0]
        self.y = dimensions[1]
        self.width = dimensions[2]
        self.height = dimensions[3]
        self.center = ( self.x+self.width/2, self.y+self.height/2 )
        self.text = text
        self.font = font
        self.color = []
        self.color.append( color_enabled )
        self.color.append( color_disabled )
        self.button_surface = pygame.transform.scale( button_surface, (self.width,self.height) )
        self.function = function
        self.enabled = True
        return
        
    def draw( self, screen ):
        # draw button
        screen.blit( self.button_surface, (self.x,self.y) )
        # draw text
        color = self.color[0] if self.enabled else self.color[1]
        surf = self.font.render( self.text, 1, color )
        surf_pos = surf.get_rect()
        surf_pos.center = self.center
        screen.blit( surf, surf_pos )
        return
    
    def clicked( self, pos ):
        return pos[0]>=self.x and pos[0]<=self.x+self.width and pos[1]>=self.y and pos[1]<=self.y+self.height
        
    def handle_click_event( self, pos ):
        if self.enabled == False:
            return
        if self.clicked(pos):
            self.function()
        return

