import data
import pygame

class Silence:
    def play(self): pass

class SoundManager:
    def __init__( self ):
        pygame.init()
        if pygame.mixer and not pygame.mixer.get_init():
            print 'Warning, no sound'
            pygame.mixer = None
        self.library = {}
        return
    
    def load_sounds( self, soundfiles ):
        for soundfile in soundfiles:
            self.load_sound( soundfile )
        return
    
    def load_sound( self, file ):
        if not pygame.mixer:
            return
        filepath = data.filepath( file )
        try:
            self.library[file] = pygame.mixer.Sound( filepath )
        except pygame.error:
            print 'Warning, unable to load,', filepath
            self.library[file] = Silence()
        return
    
    def play_music( self, file ):
        if pygame.mixer == None:
            return
        filepath = data.filepath( file )
        pygame.mixer.music.load(filepath )
        pygame.mixer.music.play( -1 )
        return
    
    def play_sound( self, file ):
        if pygame.mixer == None:
            return
        if file not in self.library.keys():
            self.library[file] = self.load_sound( file )
        self.library[file].play()
        return
